<?php
// 2006-05-02 : moku

  if (!defined('IS_ADMIN_FLAG')) {
    die('Illegal Access');
  }
  // NOTE: Debug code left in to help with creating additional product type delete-scripts

  // test if demo mode active
  if (zen_admin_demo()) {
    $_GET['action']= '';
    $messageStack->add_session(ERROR_ADMIN_DEMO, 'caution');
    zen_redirect(zen_href_link(FILENAME_CATEGORIES, 'cPath=' . $_GET['cPath'] . '&pID=' . $_GET['pID'] . (isset($_GET['page']) ? '&page=' . $_GET['page'] : '')));
  }

  $do_delete_flag = false;
  //echo 'products_id=' . $_POST['products_id'] . '<br />';
  if (isset($_POST['products_id']) && isset($_POST['product_categories']) && is_array($_POST['product_categories'])) {
    $product_id = zen_db_prepare_input($_POST['products_id']);
    $product_categories = $_POST['product_categories'];
    $do_delete_flag = true;
    if (!isset($delete_linked)) $delete_linked = 'true';
  }

  if (zen_not_null($cascaded_prod_id_for_delete) && zen_not_null($cascaded_prod_cat_for_delete) ) {
    $product_id = $cascaded_prod_id_for_delete;
    $product_categories = $cascaded_prod_cat_for_delete;
    $do_delete_flag = true;
    // no check for $delete_linked here, because it should already be passed from categories.php
  }

  if ($do_delete_flag) {
    //--------------PRODUCT_TYPE_SPECIFIC_INSTRUCTIONS_GO__BELOW_HERE--------------------------------------------------------

    // First we delete related records from related product-type tables:
    //echo 'SQL=' . "select media_id from " . TABLE_MEDIA_TO_PRODUCTS . " where products_id = '" . (int)$product_id . "'<br />";

	// Authors
    $book_authors = $db->Execute("select * from " . TABLE_BOOKS_TO_AUTHORS . "
                                 where products_id = '" . (int)$product_id . "'");
    while (!$book_authors->EOF) {
      $db->Execute("delete from " . TABLE_BOOKS_TO_AUTHORS . "
                    where book_authors_id='" . (int)zen_db_input($book_authors->fields['book_authors_id']) . "'
                    and products_id = '" . (int)$product_id . "'");
      $book_authors->MoveNext();
    }

	// Genres
    $book_genre = $db->Execute("select * from " . TABLE_BOOKS_TO_GENRES . "
                                 where products_id = '" . (int)$product_id . "'");
    while (!$book_genre->EOF) {
      $db->Execute("delete from " . TABLE_BOOKS_TO_GENRES . "
                    where book_genre_id='" . (int)zen_db_input($book_genre->fields['book_genre_id']) . "'
                    and products_id = '" . (int)$product_id . "'");
      $book_genre->MoveNext();
    }

	// Types
    $book_type = $db->Execute("select * from " . TABLE_BOOKS_TO_TYPES . "
                                 where products_id = '" . (int)$product_id . "'");
    while (!$book_type->EOF) {
    $db->Execute("delete from " . TABLE_BOOKS_TO_TYPES . "
                  where book_type_id='" . (int)zen_db_input($book_type->fields['book_type_id']) . "'
                  and products_id = '" . (int)$product_id . "'");
      $book_type->MoveNext();
    }

	// Languages
    if (defined('TABLE_PRODUCTS_LANGUAGES')) {
      $book_languages = $db->Execute("select * from " . TABLE_BOOKS_TO_LANGUAGES . "
                                      where products_id = '" . (int)$product_id . "'");
      while (!$book_languages->EOF) {
        $db->Execute("delete from " . TABLE_BOOKS_TO_LANGUAGES . "
                      where products_languages_id='" . (int)zen_db_input($book_languages->fields['products_languages_id']) . "'
                      and products_id = '" . (int)$product_id . "'");
        $book_languages->MoveNext();
      }
    }

	// Extras
    $book_extra = $db->Execute("select * from " . TABLE_PRODUCT_BOOK_EXTRA . "
                                 where products_id = '" . (int)$product_id . "'");
    if ($book_extra->RecordCount()>0) {
      $db->Execute("delete from " . TABLE_PRODUCT_BOOK_EXTRA . "
                    where products_id = '" . (int)$product_id . "'");
    }

    //--------------PRODUCT_TYPE_SPECIFIC_INSTRUCTIONS_GO__ABOVE__HERE--------------------------------------------------------


    // now do regular non-type-specific delete:

    // remove product from all its categories:
    for ($k=0, $m=sizeof($product_categories); $k<$m; $k++) {
      $db->Execute("delete from " . TABLE_PRODUCTS_TO_CATEGORIES . "
                    where products_id = '" . (int)$product_id . "'
                    and categories_id = '" . (int)$product_categories[$k] . "'");
    }

    // confirm that product is no longer linked to any categories
    $count_categories = $db->Execute("select count(categories_id) as total
                                      from " . TABLE_PRODUCTS_TO_CATEGORIES . "
                                      where products_id = '" . (int)$product_id . "'");
    // echo 'count of category links for this product=' . $count_categories->fields['total'] . '<br />';

    // if not linked to any categories, do delete:
    if ($count_categories->fields['total'] == '0') {
      zen_remove_product($product_id, $delete_linked);
      
      // BEGIN CEON URI MAPPING 1 of 1
      $db->Execute("DELETE FROM " . TABLE_CEON_URI_MAPPINGS . "
        WHERE
          (
			main_page = '" . zen_db_input(FILENAME_DOCUMENT_GENERAL_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_DOCUMENT_PRODUCT_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_BOOK_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_FREE_SHIPPING_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_MUSIC_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_REVIEWS) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_REVIEWS_INFO) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_PRODUCT_REVIEWS_WRITE) . "'
          OR
			main_page = '" . zen_db_input(FILENAME_TELL_A_FRIEND) . "'
          )
        AND
          associated_db_id = '" . (int) $product_id . "';");
      // END CEON URI MAPPING 1 of 1
    }

  } // endif $do_delete_flag

  // if this is a single-product delete, redirect to categories page
  // if not, then this file was called by the cascading delete initiated by the category-delete process
  if ($action == 'delete_product_confirm') zen_redirect(zen_href_link(FILENAME_CATEGORIES, 'cPath=' . $cPath));
?>